## stlink 1.5.0+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)
set(CMAKE_USER_MAKE_RULES_OVERRIDE cmake/c_flag_overrides.cmake)
project(stlink C)
set(PROJECT_DESCRIPTION "Open source version of the STMicroelectronics Stlink Tools")
set(STLINK_UDEV_RULES_DIR "/etc/udev/rules.d" CACHE PATH "Udev rules directory")
set(STLINK_MODPROBED_DIR "/etc/modprobe.d" CACHE PATH "modprobe.d directory")
set(LIB_INSTALL_DIR "lib" CACHE PATH "Main library directory")
set(STLINK_LIBRARY_PATH "${LIB_INSTALL_DIR}/${CMAKE_LIBRARY_PATH}" CACHE PATH "Target lib directory")

option(STLINK_GENERATE_MANPAGES "Generate manpages with pandoc" OFF)

if (POLICY CMP0042)
	# Newer cmake on MacOS should use @rpath
	cmake_policy (SET CMP0042 NEW)
endif ()

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_SOURCE_DIR}/cmake/modules")
include(cmake/Version.cmake)
include(cmake/CFlags.cmake)

###
# Dependencies
###
find_package(LibUSB REQUIRED)
if (NOT APPLE AND NOT WIN32 AND NOT CMAKE_CROSSCOMPILING)
	find_package(PkgConfig)
	pkg_check_modules(gtk gtk+-3.0)
endif ()

include(CheckIncludeFile)
CHECK_INCLUDE_FILE(sys/mman.h STLINK_HAVE_SYS_MMAN_H)
if (STLINK_HAVE_SYS_MMAN_H)
	add_definitions(-DSTLINK_HAVE_SYS_MMAN_H)
endif()

CHECK_INCLUDE_FILE(unistd.h STLINK_HAVE_UNISTD_H)
if (STLINK_HAVE_UNISTD_H)
	add_definitions(-DSTLINK_HAVE_UNISTD_H)
endif()

if (CMAKE_BUILD_TYPE STREQUAL "")
	set(CMAKE_BUILD_TYPE "Debug")
endif()

if (${CMAKE_BUILD_TYPE} MATCHES "Debug")
	include(CTest)
endif()

set(STLINK_HEADERS
	include/stlink.h
	include/stlink/usb.h
	include/stlink/sg.h
	include/stlink/logging.h
	include/stlink/mmap.h
	include/stlink/chipid.h
	include/stlink/flash_loader.h
)

set(STLINK_SOURCE
	src/chipid.c
	src/common.c
	src/usb.c
	src/sg.c
	src/logging.c
	src/flash_loader.c
)

if (WIN32 OR MSYS OR MINGW)
	set (STLINK_SOURCE "${STLINK_SOURCE};src/mmap.c;src/mingw/mingw.c")
endif ()

include_directories(${LIBUSB_INCLUDE_DIR})
include_directories(include)
include_directories(${PROJECT_BINARY_DIR}/include)
include_directories(src/mingw)
if (MSVC)
	include_directories(src/win32)
	include_directories(src/getopt)
	# Use string.h rather than strings.h and disable annoying warnings
	add_definitions(-DHAVE_STRING_H -D_CRT_SECURE_NO_WARNINGS -D_CRT_NONSTDC_NO_WARNINGS /wd4710)
endif ()

###
# Shared library
###
set(STLINK_LIB_SHARED ${PROJECT_NAME}-shared)

add_library(${STLINK_LIB_SHARED} SHARED
	${STLINK_HEADERS} # header files for ide projects generated by cmake
	${STLINK_SOURCE}
)
target_link_libraries(${STLINK_LIB_SHARED} ${LIBUSB_LIBRARY})

if (WIN32 OR MSYS OR MINGW)
	set(STLINK_SHARED_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR})
else()
	set(STLINK_SHARED_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH})
endif()

set_target_properties(${STLINK_LIB_SHARED}
	PROPERTIES SOVERSION ${PROJECT_VERSION_MAJOR}
	VERSION ${STLINK_SHARED_VERSION}
)

# Link shared library with apple OS libraries
if (APPLE)
	find_library(ObjC objc)
	find_library(CoreFoundation CoreFoundation)
	find_library(IOKit IOKit)
	target_link_libraries(${STLINK_LIB_SHARED} ${CoreFoundation} ${IOKit} ${ObjC})
endif()

if (WIN32 OR MSYS OR MINGW)
	target_link_libraries(${STLINK_LIB_SHARED} ${LIBUSB_LIBRARY} wsock32 ws2_32)
else()
	target_link_libraries(${STLINK_LIB_SHARED} ${LIBUSB_LIBRARY})
endif()

install(TARGETS ${STLINK_LIB_SHARED}
	DESTINATION ${STLINK_LIBRARY_PATH}
)

###
# Static library
###
set(STLINK_LIB_STATIC ${PROJECT_NAME}-static)

add_library(${STLINK_LIB_STATIC} STATIC
	${STLINK_HEADERS} # header files for ide projects generated by cmake
	${STLINK_SOURCE}
)

# Link shared library with apple OS libraries
if (APPLE)
	find_library(ObjC objc)
	find_library(CoreFoundation CoreFoundation)
	find_library(IOKit IOKit)
	target_link_libraries(${STLINK_LIB_STATIC} ${CoreFoundation} ${IOKit} ${ObjC})
endif()
	
if (WIN32 OR MSYS OR MINGW)
	target_link_libraries(${STLINK_LIB_STATIC} ${LIBUSB_LIBRARY} wsock32 ws2_32)
else()
	target_link_libraries(${STLINK_LIB_STATIC} ${LIBUSB_LIBRARY})
endif()

set_target_properties(${STLINK_LIB_STATIC} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})

install(TARGETS ${STLINK_LIB_STATIC}
	ARCHIVE DESTINATION ${STLINK_LIBRARY_PATH}
)

###
# Tools
###
add_executable(st-flash src/tools/flash.c src/tools/flash_opts.c)
if (WIN32 OR APPLE)
	target_link_libraries(st-flash ${STLINK_LIB_STATIC})
else()
	target_link_libraries(st-flash ${STLINK_LIB_SHARED})
endif()

add_executable(st-info src/tools/info.c)
if (WIN32 OR APPLE)
	target_link_libraries(st-info ${STLINK_LIB_STATIC})
else()
	target_link_libraries(st-info ${STLINK_LIB_SHARED})
endif()

install(TARGETS st-flash st-info
	RUNTIME DESTINATION bin
)

if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
	file(GLOB RULES_FILES etc/udev/rules.d/*.rules)
	install(FILES etc/modprobe.d/stlink_v1.conf
	DESTINATION ${STLINK_MODPROBED_DIR}/)
	install(FILES ${RULES_FILES}
	DESTINATION ${STLINK_UDEV_RULES_DIR}/)
endif()

add_subdirectory(src/gdbserver)
add_subdirectory(src/tools/gui)

###
# Others
###
add_subdirectory(usr/lib/pkgconfig)
add_subdirectory(include)
add_subdirectory(doc/man)
add_subdirectory(tests)

include(cmake/CPackConfig.cmake)
include(CPack)

=== include/CMakeLists.txt ===
configure_file(
	"${PROJECT_SOURCE_DIR}/include/stlink/version.h.in"
	"${CMAKE_BINARY_DIR}/include/stlink/version.h"
)
file(GLOB STLINK_HEADERS
	"stlink/*.h"
	"${CMAKE_BINARY_DIR}/include/stlink/*.h"
)
install(FILES ${CMAKE_SOURCE_DIR}/include/stlink.h
	DESTINATION include/${CMAKE_LIBRARY_PATH}
)
install(FILES ${STLINK_HEADERS}
	DESTINATION include/${CMAKE_LIBRARY_PATH}/stlink
)

=== usr/lib/pkgconfig/CMakeLists.txt ===
set(PKG_CONFIG_LIBDIR     "\${prefix}/lib/\${deb_host_multiarch}")
set(PKG_CONFIG_INCLUDEDIR "\${prefix}/include/\${deb_host_multiarch}/${PROJECT_NAME}-${PROJECT_VERSION}")
set(PKG_CONFIG_LIBS       "-L\${libdir} -l:libstlink.so.${PROJECT_VERSION_MAJOR}")
set(PKG_CONFIG_CFLAGS     "-I\${includedir}")
set(PKG_CONFIG_REQUIRES   "libusb-1.0")

configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/pkg-config.pc.cmake"
	"${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
	DESTINATION ${STLINK_LIBRARY_PATH}/pkgconfig/
)

=== debian/changelog ===
stlink (1.5.0+ds-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Luca Boccassi <bluca@debian.org>  Mon, 21 May 2018 10:25:20 +0100

stlink (1.5.0+ds-2) unstable; urgency=medium

  * Backport patch to fix build with libusb 1.0.22.

 -- Luca Boccassi <bluca@debian.org>  Tue, 15 May 2018 19:16:50 +0100

stlink (1.5.0+ds-1) unstable; urgency=medium

  * Upload to unstable. (Closes: #869421)

 -- Luca Boccassi <bluca@debian.org>  Fri, 16 Mar 2018 16:56:17 +0000

stlink (1.5.0) unstable; urgency=medium

  [ Jerry Jacobs ]
  * README.md: Update version badge to v1.4.0

  [ Viallard Anthony ]
  * Add support of STM32L496xx/4A6xx devices (#615)

  [ rdlim ]
  * Fix verification of flash error for STM32L496x device (#617) (#618)

  [ dflogeras ]
  * Add note about availability in Gentoo package manager (#622)

  [ yaofei zheng ]
  * update debian package version (#630)

  [ Lyle Cheatham ]
  * Minor formatting fix in FAQ section of README.md (#631)

  [ Vasiliy Glazov ]
  * README.md: Added information about Fedora and RedHat/CentOS packages.
    (#635)
  * Added LIB_INSTALL_DIR to correct libs install on 64-bit systems (#636)

  [ Gwenhael Goavec-Merou ]
  * fix write for microcontroler with RAM size less or equal to 32K (#637)

  [ Mateusz Krawiec ]
  * Fix memory map for stm32l496xx boards. (#639)

  [ Rüdiger Fortanier ]
  * Add unknown chip output (#641)

  [ Slyshyk Oleksiy ]
  * fix __FILE__ base name extraction,  #628 (#648)

  [ texane ]
  * STM32F72xx73xx support, from bob.feretich@rafresearch.com

  [ Kirill Kolyshkin ]
  * debian/triggers: add (to run ldconfig) (#664)

  [ Slyshyk Oleksiy ]
  * Try to fix #666 issue (#667)
  * Try to fix 666 issue (#668)

  [ Jerry Jacobs ]
  * Update ChangeLog.md
  * Update README.md

  [ texane ]
  * STM32F042K6 Nucleo-32 Board reported to work, by frank@bauernoeppel.de

  [ Anatol Pomozov ]
  * Update .version file to match release number (#670)

 -- Anatol Pomozov <anatol.pomozov@gmail.com>  Mon, 19 Feb 2018 11:00:29 -0800

libstlink (1.4.0) unstable; urgency=low

  * Major changes and added features
    - Add support for STM32L452 target (#608)
    - Initial support to compile with Microsoft Visual Studio 2017 (#602)
    - Added support for flashing second bank on STM32F10x_XL (#592)
    - Add support for STM32L011 target (#572)
    - Allow building of debian package with CPack (@xor-gate)
  * Updates and fixes
    - Fix compilation with GCC 7 (#590)
    - Skip GTK detection if we're cross-compiling (#588)
    - Fix possible memory leak (#570)
    - Fix building with mingw64 (#569, #610)
    - Update libusb to 1.0.21 for Windows (#562)
    - Fixing low-voltage flashing on STM32F7 parts. (#567)
    - Update libusb to 1.0.21 for Windows (#562)

 -- Andrew 'Necromant' Andrianov <andrew@ncrmnt.org>  Sat, 01 Jul 2017 00:00:00 +0000

libstlink (1.3.1) unstable; urgency=low

  * Major changes and added features:
    - Add preliminary support for STM32L011 to see it after probe (chipid 0x457) (@xor-gate)
    - Strip full paths to source files in log (commit #2c0ab7f)
    - Add support for STM32F413 target (#549)
    - Add support for Semihosting SYS_READC (#546)
  * Updates and fixes:
    - Update documentation markdown files
    - Compilation fixes (#552)
    - Fix compilation when path includes spaces (#561)

 -- Andrew 'Necromant' Andrianov <andrew@ncrmnt.org>  Sat, 25 Feb 2017 00:00:00 +0000

libstlink (1.3.0) unstable; urgency=low

  * Major changes and added features:
    - Deprecation of autotools (autoconf, automake) (@xor-gate)
    - Removal of undocumented st-term utility, which is now replaced by st-util ARM semihosting feature (#3fd0f09)
    - Add support for native debian packaging (#444, #485)
    - Add intel hex file reading for st-flash (#459)
    - Add --reset command to st-flash (#505)
    - Support serial numbers argument for st-util and st-flash for multi-programmer setups (#541)
    - Add kill ('k') command to gdb-server for st-util (#9804416)
    - Add manpages (generated with pandoc from Markdown) (#464)
    - Rewrite commandline parsing for st-flash (#459)
    - Add support for ARM semihosting to st-util (#454, #455)
  * Chip support added for:
    - STM32L432 (#501)
    - STM32F412 (#538)
    - STM32F410 (#9c635e4)
    - Add memory map for STM32F401XE (#460)
    - L0x Category 5 devices (#406)
    - Add L0 Category 2 device (chip id: 0x425) (#72b8e5e)
  * Updates and fixes:
    - Fixed STM32F030 erase error (#442)
    - Fixed Cygwin build (#68b0f3b)
    - Reset flash mass erase (MER) bit after mass erase for safety (#489)
    - Fix memory map for STM32F4 (@zulusw)
    - Fix STM32L-problem with flash loader (issue #390) (Tom de Boer)
    - st-util don't read target voltage on startup as it crashes STM32F100 (probably stlink/v1) (Greg Alexander)
    - Do a JTAG reset prior to reading CPU information when processor is in deep sleep (@andyg24)
    - Redesign of st-flash commandline options parsing (pull-request #459) (@dev26th)

 -- Andrew 'Necromant' Andrianov <andrew@ncrmnt.org>  Sat, 28 Jan 2017 00:00:00 +0000

libstlink (1.2.1) unstable; urgency=low

  * Initial Debian-Packaged Release.

 -- Andrew 'Necromant' Andrianov <andrew@ncrmnt.org>  Sat, 09 Jul 2016 23:16:07 +0300

=== debian/control ===
Source: stlink
Priority: optional
Maintainer: Luca Boccassi <bluca@debian.org>
Build-Depends: debhelper (>= 9), cmake, libusb-1.0-0-dev, libgtk-3-dev
Standards-Version: 4.1.3
Section: electronics
Homepage: https://github.com/texane/stlink
Vcs-Git: https://github.com/bluca/stlink.git
Vcs-Browser: https://github.com/bluca/stlink

Package: libstlink-dev
Section: libdevel
Architecture: any
Depends: libstlink1 (= ${binary:Version}), ${misc:Depends}
Description: OpenSource ST-Link tools replacement.
 Flashing tools for STMicroelectronics STM32VL and STM32L. The transport layers
 STLINKv1 and STLINKv2 are supported.
 .
 This package contains the development files for stlink.

Package: libstlink1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: OpenSource ST-Link tools replacement.
 Flashing tools for STMicroelectronics STM32VL and STM32L. The transport layers
 STLINKv1 and STLINKv2 are supported.
 .
 This package contains the shared library for stlink.

Package: stlink-tools
Architecture: any
Depends: libstlink1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: OpenSource ST-Link tools replacement.
 Flashing tools for STMicroelectronics STM32VL and STM32L. The transport layers
 STLINKv1 and STLINKv2 are supported.
 .
 This package contains commandline utilities for stlink, and modprobe and
 udev rules.

Package: stlink-gui
Architecture: any
Depends: libstlink1 (= ${binary:Version}), stlink-tools (= ${binary:Version}),
 ${shlibs:Depends}, ${misc:Depends}
Description: OpenSource ST-Link tools replacement.
 Flashing tools for STMicroelectronics STM32VL and STM32L. The transport layers
 STLINKv1 and STLINKv2 are supported.
 .
 This package contains a GUI tool for stlink.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure -- \
    -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
    -DSTLINK_UDEV_RULES_DIR='/lib/udev/rules.d'

## stlink 1.5.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,8 +4,23 @@
 set(PROJECT_DESCRIPTION "Open source version of the STMicroelectronics Stlink Tools")
 set(STLINK_UDEV_RULES_DIR "/etc/udev/rules.d" CACHE PATH "Udev rules directory")
 set(STLINK_MODPROBED_DIR "/etc/modprobe.d" CACHE PATH "modprobe.d directory")
-set(LIB_INSTALL_DIR "lib" CACHE PATH "Main library directory")
-set(STLINK_LIBRARY_PATH "${LIB_INSTALL_DIR}/${CMAKE_LIBRARY_PATH}" CACHE PATH "Target lib directory")
+set(STLINK_STATIC_LIB ON CACHE BOOL "Install static lib")
+
+if( IS_DIRECTORY ${LIB_INSTALL_DIR})
+    set(LIB_INSTALL_DIR ${LIB_INSTALL_DIR} CACHE PATH "Main library directory")
+    set(STLINK_LIBRARY_PATH "${LIB_INSTALL_DIR}")
+else()
+    set(LIB_INSTALL_DIR "lib" CACHE PATH "Main library directory")
+    set(STLINK_LIBRARY_PATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}" )
+endif()
+
+if( IS_DIRECTORY ${INCLUDE_INSTALL_DIR})
+    set(INCLUDE_INSTALL_DIR ${INCLUDE_INSTALL_DIR} CACHE PATH "Main include directory")
+    set(STLINK_INCLUDE_PATH "${INCLUDE_INSTALL_DIR}" )
+else()
+    set(INCLUDE_INSTALL_DIR "include" CACHE PATH "Main include directory")
+    set(STLINK_INCLUDE_PATH "${CMAKE_INSTALL_PREFIX}/${INCLUDE_INSTALL_DIR}")
+endif()
 
 option(STLINK_GENERATE_MANPAGES "Generate manpages with pandoc" OFF)
 
@@ -16,7 +31,9 @@
 
 set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_SOURCE_DIR}/cmake/modules")
 include(cmake/Version.cmake)
-include(cmake/CFlags.cmake)
+if(NOT MSVC)
+    include(cmake/CFlags.cmake)
+endif()
 
 ###
 # Dependencies
@@ -83,7 +100,11 @@
 ###
 # Shared library
 ###
+if (NOT WIN32)
+set(STLINK_LIB_SHARED ${PROJECT_NAME})
+else ()
 set(STLINK_LIB_SHARED ${PROJECT_NAME}-shared)
+endif()
 
 add_library(${STLINK_LIB_SHARED} SHARED
 	${STLINK_HEADERS} # header files for ide projects generated by cmake
@@ -116,6 +137,7 @@
 	target_link_libraries(${STLINK_LIB_SHARED} ${LIBUSB_LIBRARY})
 endif()
 
+
 install(TARGETS ${STLINK_LIB_SHARED}
 	DESTINATION ${STLINK_LIBRARY_PATH}
 )
@@ -146,9 +168,11 @@
 
 set_target_properties(${STLINK_LIB_STATIC} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
 
-install(TARGETS ${STLINK_LIB_STATIC}
-	ARCHIVE DESTINATION ${STLINK_LIBRARY_PATH}
-)
+if (STLINK_STATIC_LIB)
+    install(TARGETS ${STLINK_LIB_STATIC}
+        ARCHIVE DESTINATION ${STLINK_LIBRARY_PATH}
+    )
+endif()
 
 ###
 # Tools

=== include/CMakeLists.txt ===
--- 
+++ 
@@ -7,8 +7,8 @@
 	"${CMAKE_BINARY_DIR}/include/stlink/*.h"
 )
 install(FILES ${CMAKE_SOURCE_DIR}/include/stlink.h
-	DESTINATION include/${CMAKE_LIBRARY_PATH}
+    DESTINATION ${STLINK_INCLUDE_PATH}
 )
 install(FILES ${STLINK_HEADERS}
-	DESTINATION include/${CMAKE_LIBRARY_PATH}/stlink
+    DESTINATION ${STLINK_INCLUDE_PATH}/stlink
 )

=== doc/man/CMakeLists.txt ===
set(MANPAGES
	st-util
	st-flash
	st-info
)

# Only generate manpages with pandoc in Debug builds
if(${STLINK_GENERATE_MANPAGES})
	include(pandocology)

	foreach(manpage ${MANPAGES})
		add_document(
			${manpage}.1
			SOURCES ${manpage}.md
			PANDOC_DIRECTIVES -s -t man
			PRODUCT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
		)
	endforeach()
else()
	message(STATUS "Manpage generation disabled")
endif()

# Install from output folder or this folder
foreach(manpage ${MANPAGES})
	if(EXISTS ${CMAKE_CURRENT_BINARY_DIR}/${manpage}.1)
		set(f "${CMAKE_CURRENT_BINARY_DIR}/${manpage}.1")
	elseif(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${manpage}.1")
		set(f "${CMAKE_CURRENT_SOURCE_DIR}/${manpage}.1")
	else()
		message(AUTHOR_WARNING "Manpage ${manpage} not generated")
	endif()

	if (f AND NOT WIN32)
		install(FILES ${f} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1)
		unset(f)
	endif()
endforeach()

=== src/tools/gui/CMakeLists.txt ===
if (NOT gtk_FOUND)
	return()
endif()

set(GUI_SOURCES stlink-gui.c stlink-gui.h)
set(INSTALLED_UI_DIR share/stlink)

include_directories(SYSTEM ${gtk_INCLUDE_DIRS})

add_executable(stlink-gui-local ${GUI_SOURCES})
set_target_properties(stlink-gui-local PROPERTIES
                      COMPILE_DEFINITIONS STLINK_UI_DIR="${CMAKE_CURRENT_SOURCE_DIR}/gui")
target_link_libraries(stlink-gui-local ${STLINK_LIB_STATIC} ${gtk_LDFLAGS})


add_executable(stlink-gui ${GUI_SOURCES})
set_target_properties(stlink-gui PROPERTIES
                      COMPILE_DEFINITIONS STLINK_UI_DIR="${CMAKE_INSTALL_PREFIX}/${INSTALLED_UI_DIR}")
target_link_libraries(stlink-gui ${STLINK_LIB_STATIC} ${gtk_LDFLAGS})

install(TARGETS stlink-gui
        RUNTIME DESTINATION bin)
install(FILES stlink-gui.ui
        DESTINATION ${INSTALLED_UI_DIR})
if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    # Install desktop entry
    install(FILES stlink-gui.desktop 
            DESTINATION share/applications)
    # Install icon
    install(FILES art/stlink-gui.svg 
            DESTINATION share/icons/hicolor/scalable/apps)
endif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")

=== debian/changelog ===
stlink (1.5.1+ds-2) unstable; urgency=medium

  * Mark library packages as Multi-Arch: same.
  * Apply cross.patch to fix cross-compiling the GUI. Thanks Helmut for
    the patch! (Closes: #941320)
  * Vcs-Git: add -b debian
  * Set Rules-Requires-Root: no
  * Bump Standards-Version to 4.4.0

 -- Luca Boccassi <bluca@debian.org>  Sun, 29 Sep 2019 12:50:58 +0100

stlink (1.5.1+ds-1) unstable; urgency=medium

  * Merge tag 'v1.5.1' into debian. See upstream changelog for info:
    https://github.com/texane/stlink/releases/tag/v1.5.1
  * Mark packages as linux-any, other systems not supported.

 -- Luca Boccassi <bluca@debian.org>  Fri, 28 Sep 2018 10:26:39 +0100

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,17 @@
 Priority: optional
 Maintainer: Luca Boccassi <bluca@debian.org>
 Build-Depends: debhelper (>= 9), cmake, libusb-1.0-0-dev, libgtk-3-dev
-Standards-Version: 4.1.3
+Standards-Version: 4.4.0
+Rules-Requires-Root: no
 Section: electronics
 Homepage: https://github.com/texane/stlink
-Vcs-Git: https://github.com/bluca/stlink.git
+Vcs-Git: https://github.com/bluca/stlink.git -b debian
 Vcs-Browser: https://github.com/bluca/stlink
 
 Package: libstlink-dev
 Section: libdevel
-Architecture: any
+Architecture: linux-any
+Multi-Arch: same
 Depends: libstlink1 (= ${binary:Version}), ${misc:Depends}
 Description: OpenSource ST-Link tools replacement.
  Flashing tools for STMicroelectronics STM32VL and STM32L. The transport layers
@@ -20,7 +22,8 @@
 
 Package: libstlink1
 Section: libs
-Architecture: any
+Architecture: linux-any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: OpenSource ST-Link tools replacement.
  Flashing tools for STMicroelectronics STM32VL and STM32L. The transport layers
@@ -29,7 +32,7 @@
  This package contains the shared library for stlink.
 
 Package: stlink-tools
-Architecture: any
+Architecture: linux-any
 Depends: libstlink1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Description: OpenSource ST-Link tools replacement.
  Flashing tools for STMicroelectronics STM32VL and STM32L. The transport layers
@@ -39,7 +42,7 @@
  udev rules.
 
 Package: stlink-gui
-Architecture: any
+Architecture: linux-any
 Depends: libstlink1 (= ${binary:Version}), stlink-tools (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
 Description: OpenSource ST-Link tools replacement.

## stlink 1.6.0%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,6 +23,8 @@
 endif()
 
 option(STLINK_GENERATE_MANPAGES "Generate manpages with pandoc" OFF)
+option(STLINK_INSTALL_UDEV_RULES "Install udev rules files" ON)
+option(STLINK_INSTALL_MODPROBE_CONF "Install modprobe conf files" ON)
 
 if (POLICY CMP0042)
 	# Newer cmake on MacOS should use @rpath
@@ -84,6 +86,7 @@
 
 if (WIN32 OR MSYS OR MINGW)
 	set (STLINK_SOURCE "${STLINK_SOURCE};src/mmap.c;src/mingw/mingw.c")
+	set (STLINK_HEADERS "${STLINK_HEADERS};src/mingw/mingw.h")
 endif ()
 
 include_directories(${LIBUSB_INCLUDE_DIR})
@@ -196,11 +199,15 @@
 )
 
 if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
-	file(GLOB RULES_FILES etc/udev/rules.d/*.rules)
-	install(FILES etc/modprobe.d/stlink_v1.conf
-	DESTINATION ${STLINK_MODPROBED_DIR}/)
-	install(FILES ${RULES_FILES}
-	DESTINATION ${STLINK_UDEV_RULES_DIR}/)
+	if (STLINK_INSTALL_MODPROBE_CONF)
+		install(FILES etc/modprobe.d/stlink_v1.conf
+		DESTINATION ${STLINK_MODPROBED_DIR}/)
+	endif()
+	if (STLINK_INSTALL_UDEV_RULES)
+		file(GLOB RULES_FILES etc/udev/rules.d/*.rules)
+		install(FILES ${RULES_FILES}
+		DESTINATION ${STLINK_UDEV_RULES_DIR}/)
+	endif()
 endif()
 
 add_subdirectory(src/gdbserver)

=== Makefile ===
##
# This Makefile is used to drive building of Debug and Release
#  targets of CMake
##
MAKEFLAGS += -s

all: release
ci: debug release test

help:
	@echo "      release: Run a release build"
	@echo "        debug: Run a debug build"
	@echo "         lint: Lint check all source-code"
	@echo "         test: Build and run tests"
	@echo "        clean: Clean all build output"
	@echo "rebuild_cache: Rebuild all CMake caches"

rebuild_cache: build/Debug build/Release
	@$(MAKE) -C build/Debug rebuild_cache
	@$(MAKE) -C build/Release rebuild_cache

debug: build/Debug
	@echo "[DEBUG]"
	@$(MAKE) -C build/Debug

release: build/Release
	@echo "[RELEASE]"
	@$(MAKE) -C build/Release

package: build/Release
	@echo "[PACKAGE] Release"
	@$(MAKE) -C build/Release package

test: debug
	@$(MAKE) -C build/Debug test

build/Debug:
	@mkdir -p $@
	@cd $@ && cmake -DCMAKE_BUILD_TYPE=Debug $(CMAKEFLAGS) ../../

build/Release:
	@mkdir -p $@
	@cd $@ && cmake -Wno-dev -DCMAKE_BUILD_TYPE=Release $(CMAKEFLAGS) ../../

clean:
	@echo "[CLEAN]"
	@rm -Rf build

.PHONY: clean

## stlink 1.6.0+ds

=== tests/CMakeLists.txt ===
set(TESTS
	usb
	sg
)

foreach(test ${TESTS})
	add_executable(${test} ${test}.c)
	add_dependencies(${test} ${STLINK_LIB_STATIC})
	target_link_libraries(${test} ${STLINK_LIB_STATIC})
	add_test(${test} ${CMAKE_CURRENT_BINARY_DIR}/${test})
endforeach()

add_executable(flash flash.c "${CMAKE_SOURCE_DIR}/src/tools/flash_opts.c")
target_link_libraries(flash ${STLINK_LIB_STATIC})
add_test(flash ${CMAKE_CURRENT_BINARY_DIR}/flash)

=== doc/app-example/CMakeLists.txt ===
# Warning: This example assumes that you are building on a host
# with pkg-config available (e.g. linux). The logic required to
# build under windows/mingw and/or mac was intentionally omitted
# to keep this CMakeLists as small as possible

cmake_minimum_required(VERSION 2.8)

project(st-hello)
set(PROJECT_VERSION   0.1)
set(SRCS main.c)

find_package(PkgConfig)
pkg_check_modules(STLINK REQUIRED stlink)

set(CMAKE_C_FLAGS " ${STLINK_CFLAGS_OTHER} -Wall -Werror")

include_directories(
    ${STLINK_INCLUDE_DIRS}
)

add_executable(${PROJECT_NAME} ${SRCS})

target_link_libraries(${PROJECT_NAME}
    ${STLINK_LIBRARIES}
)

install(TARGETS ${PROJECT_NAME}
        DESTINATION bin)

=== src/gdbserver/CMakeLists.txt ===
set(STUTIL_SOURCE
    gdb-remote.c
    gdb-remote.h
    gdb-server.c
    gdb-server.h
    semihosting.c
    semihosting.h)

if (MSVC)
    # We need a getopt from somewhere...
    set(STUTIL_SOURCE "${STUTIL_SOURCE};../getopt/getopt.c")
endif()

add_executable(st-util ${STUTIL_SOURCE})

if (WIN32 OR APPLE)
	target_link_libraries(st-util ${STLINK_LIB_STATIC})
else()
	target_link_libraries(st-util ${STLINK_LIB_SHARED})
endif()

install(TARGETS st-util
	RUNTIME DESTINATION bin
)

=== src/tools/gui/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 
 add_executable(stlink-gui-local ${GUI_SOURCES})
 set_target_properties(stlink-gui-local PROPERTIES
-                      COMPILE_DEFINITIONS STLINK_UI_DIR="${CMAKE_CURRENT_SOURCE_DIR}/gui")
+                      COMPILE_DEFINITIONS STLINK_UI_DIR="${CMAKE_CURRENT_SOURCE_DIR}")
 target_link_libraries(stlink-gui-local ${STLINK_LIB_STATIC} ${gtk_LDFLAGS})

=== usr/lib/pkgconfig/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 set(PKG_CONFIG_LIBDIR     "\${prefix}/lib/\${deb_host_multiarch}")
-set(PKG_CONFIG_INCLUDEDIR "\${prefix}/include/\${deb_host_multiarch}/${PROJECT_NAME}-${PROJECT_VERSION}")
+set(PKG_CONFIG_INCLUDEDIR "\${prefix}/include/\${deb_host_multiarch}/${PROJECT_NAME}")
 set(PKG_CONFIG_LIBS       "-L\${libdir} -l:libstlink.so.${PROJECT_VERSION_MAJOR}")
 set(PKG_CONFIG_CFLAGS     "-I\${includedir}")
 set(PKG_CONFIG_REQUIRES   "libusb-1.0")

=== debian/changelog ===
stlink (1.6.0+ds-1) unstable; urgency=medium

  * Merge tag 'v1.6.0' into debian
  * Bump Standards-Version to 4.5.0, no changes.
  * Update libstlink1 symbols file for 1.6.0.

 -- Luca Boccassi <bluca@debian.org>  Tue, 25 Feb 2020 22:08:33 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Luca Boccassi <bluca@debian.org>
 Build-Depends: debhelper (>= 9), cmake, libusb-1.0-0-dev, libgtk-3-dev
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Section: electronics
 Homepage: https://github.com/texane/stlink

=== debian/rules ===
--- 
+++ 
@@ -15,5 +15,5 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-    -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
+    -DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
     -DSTLINK_UDEV_RULES_DIR='/lib/udev/rules.d'

=== debian/watch ===
version=3
opts=dversionmangle=s/\+ds$//,repacksuffix=+ds,filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/<project>-$1\.tar\.gz/ \
  https://github.com/texane/stlink/tags .*/v?(\d\S+)\.tar\.gz

## stlink 1.6.1+ds

=== CMakeLists.txt ===
###
# General cmake settings
###

cmake_minimum_required(VERSION 3.4.2)
cmake_policy(SET CMP0042 NEW)
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_SOURCE_DIR}/cmake/modules")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

###
# General project settings
###

project(stlink C)
set(PROJECT_DESCRIPTION "Open source version of the STMicroelectronics ST-LINK Tools")
include(GNUInstallDirs) # Define GNU standard installation directories

## Determine project version
include(${CMAKE_MODULE_PATH}/get_version.cmake)

## Set C build flags
if (NOT MSVC)
    include(${CMAKE_MODULE_PATH}/c_flags.cmake)
else ()
    message(STATUS "MSVC C Flags override to /MT")
    set(CMAKE_C_FLAGS_DEBUG_INIT          "/D_DEBUG /MTd /Zi /Ob0 /Od /RTC1")
    set(CMAKE_C_FLAGS_MINSIZEREL_INIT     "/MT /O1 /Ob1 /D NDEBUG")
    set(CMAKE_C_FLAGS_RELEASE_INIT        "/MT /O2 /Ob2 /D NDEBUG")
    set(CMAKE_C_FLAGS_RELWITHDEBINFO_INIT "/MT /Zi /O2 /Ob1 /D NDEBUG")
endif ()

## Set installation directories for header files                                ### TODO: Clean this up...
if (IS_DIRECTORY ${INCLUDE_INSTALL_DIR})
    set(INCLUDE_INSTALL_DIR ${INCLUDE_INSTALL_DIR} CACHE PATH "Main include directory")
    set(STLINK_INCLUDE_PATH "${INCLUDE_INSTALL_DIR}")
else ()
    set(INCLUDE_INSTALL_DIR "include" CACHE PATH "Main include directory")
    set(STLINK_INCLUDE_PATH "${CMAKE_INSTALL_PREFIX}/${INCLUDE_INSTALL_DIR}")
endif ()


###
# Dependencies
###

find_package(libusb REQUIRED)

## Package configuration (pkg-config) on unix-based systems
if (NOT WIN32 AND NOT CMAKE_CROSSCOMPILING)
    #add_subdirectory(cmake/pkgconfig)
    find_package(PkgConfig)
    pkg_check_modules(GTK3 gtk+-3.0)
endif ()

## Check for system-specific additional header files and libraries
include(CheckIncludeFile)

CHECK_INCLUDE_FILE(sys/mman.h STLINK_HAVE_SYS_MMAN_H)
if (STLINK_HAVE_SYS_MMAN_H)
    add_definitions(-DSTLINK_HAVE_SYS_MMAN_H)
endif ()

CHECK_INCLUDE_FILE(unistd.h STLINK_HAVE_UNISTD_H)
if (STLINK_HAVE_UNISTD_H)
    add_definitions(-DSTLINK_HAVE_UNISTD_H)
endif ()

include(CheckLibraryExists)

CHECK_LIBRARY_EXISTS(ssp __stack_chk_fail "" _stack_chk_fail_exists)
if (_stack_chk_fail_exists)
    set(SSP_LIB -static ssp)
else ()
    set(SSP_LIB "")
endif ()


###
# Main build process
###

## Define include directories to avoid absolute paths for header defines
include_directories(${LIBUSB_INCLUDE_DIR})

# ====
include_directories(${PROJECT_SOURCE_DIR}/include)                              ### TODO: Clean this up...
include_directories(${PROJECT_BINARY_DIR}/include/stlink)
include_directories(${PROJECT_SOURCE_DIR}/include/stlink)
include_directories(${PROJECT_SOURCE_DIR}/include/stlink/tools)
# ====

include_directories(src)
include_directories(src/tools)                                                  ### TODO: Clean this up...

set(STLINK_HEADERS
        include/stlink.h
        include/stlink/backend.h
        include/stlink/chipid.h
        include/stlink/commands.h
        include/stlink/flash_loader.h
        include/stlink/reg.h
        src/logging.h
        src/md5.h
        src/sg.h
        src/usb.h
        )

set(STLINK_SOURCE
        src/common.c
        src/chipid.c
        src/flash_loader.c
        src/logging.c
        src/md5.c
        src/sg.c
        src/usb.c
        )

if (WIN32 OR MINGW OR MSYS)
    include_directories(src/mingw)
    set(STLINK_SOURCE "${STLINK_SOURCE};src/mmap.c;src/mingw/mingw.c")
    set(STLINK_HEADERS "${STLINK_HEADERS};src/mmap.h;src/mingw/mingw.h")
endif ()

if (MSVC)
    include_directories(src/win32)
    include_directories(src/getopt)
    # Use string.h rather than strings.h and disable annoying warnings
    add_definitions(-DHAVE_STRING_H -D_CRT_SECURE_NO_WARNINGS -D_CRT_NONSTDC_NO_WARNINGS /wd4710)
endif ()

## Include test execution for test-targets for target Debug
if (${CMAKE_BUILD_TYPE} MATCHES "Debug")
    include(CTest)
endif ()


###
# Libraries
###

set(STLINK_LIBRARY_PATH ${CMAKE_INSTALL_LIBDIR} CACHE PATH "Main library install directory")

# Set the environment variable LD_LIBRARY_PATH to point to /usr/local/lib (per default).
execute_process (COMMAND bash -c "export LD_LIBRARY_PATH="${CMAKE_INSTALL_LIBDIR}" ")


###
# Shared library
###

# Set library name
if (NOT WIN32)
    set(STLINK_LIB_SHARED ${PROJECT_NAME})
else (WIN32)
    set(STLINK_LIB_SHARED ${PROJECT_NAME}-shared)
endif ()

add_library(${STLINK_LIB_SHARED} SHARED ${STLINK_HEADERS} ${STLINK_SOURCE})

set(STLINK_SHARED_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH})
message(STATUS "STLINK_LIB_SHARED: ${STLINK_LIB_SHARED}")
message(STATUS "PROJECT_VERSION_MAJOR: ${PROJECT_VERSION_MAJOR}")
message(STATUS "VERSION: ${STLINK_SHARED_VERSION}")

set_target_properties(${STLINK_LIB_SHARED} PROPERTIES
        SOVERSION ${PROJECT_VERSION_MAJOR}
        VERSION ${STLINK_SHARED_VERSION}
        OUTPUT_NAME ${PROJECT_NAME}
        )

# Link shared library
if (APPLE)     # ... with Apple macOS libraries
    find_library(ObjC objc)
    find_library(CoreFoundation CoreFoundation)
    find_library(IOKit IOKit)
    target_link_libraries(${STLINK_LIB_SHARED} ${LIBUSB_LIBRARY} ${SSP_LIB} ${ObjC} ${CoreFoundation} ${IOKit})
elseif (WIN32) # ... with Windows libraries
    target_link_libraries(${STLINK_LIB_SHARED} ${LIBUSB_LIBRARY} ${SSP_LIB} wsock32 ws2_32)
else ()
    target_link_libraries(${STLINK_LIB_SHARED} ${LIBUSB_LIBRARY} ${SSP_LIB})
endif ()

install(TARGETS ${STLINK_LIB_SHARED} DESTINATION ${STLINK_LIBRARY_PATH})


###
# Static library
###

# Set library name
set(STLINK_LIB_STATIC ${PROJECT_NAME}-static)

add_library(${STLINK_LIB_STATIC} STATIC ${STLINK_HEADERS} ${STLINK_SOURCE})

set(STLINK_STATIC_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH})
message(STATUS "STLINK_LIB_STATIC: ${STLINK_LIB_STATIC}")
message(STATUS "PROJECT_VERSION_MAJOR: ${PROJECT_VERSION_MAJOR}")
message(STATUS "VERSION: ${STLINK_STATIC_VERSION}")

set_target_properties(${STLINK_LIB_STATIC} PROPERTIES
        SOVERSION ${PROJECT_VERSION_MAJOR}
        VERSION ${STLINK_STATIC_VERSION}
        OUTPUT_NAME ${PROJECT_NAME}
        )

# Link static library
if (APPLE)     # ... with Apple macOS libraries
    find_library(ObjC objc)
    find_library(CoreFoundation CoreFoundation)
    find_library(IOKit IOKit)
    target_link_libraries(${STLINK_LIB_STATIC} ${LIBUSB_LIBRARY} ${SSP_LIB} ${ObjC} ${CoreFoundation} ${IOKit})
elseif (WIN32) # ... with Windows libraries
    target_link_libraries(${STLINK_LIB_STATIC} ${LIBUSB_LIBRARY} ${SSP_LIB} wsock32 ws2_32)
else ()
    target_link_libraries(${STLINK_LIB_STATIC} ${LIBUSB_LIBRARY} ${SSP_LIB})
endif ()

install(TARGETS ${STLINK_LIB_STATIC} ARCHIVE DESTINATION ${STLINK_LIBRARY_PATH})


###
# Build toolset executables
###

set(ST-UTIL_SOURCES src/st-util/gdb-remote.c src/st-util/gdb-server.c src/st-util/semihosting.c)

if (MSVC)
    # Add getopt to sources
    set(ST-UTIL_SOURCES "${ST-UTIL_SOURCES};src/getopt/getopt.c")
endif ()

add_executable(st-flash src/tools/flash.c src/tools/flash_opts.c)
add_executable(st-info src/tools/info.c)
add_executable(st-util ${ST-UTIL_SOURCES})

if (WIN32 OR APPLE)
    target_link_libraries(st-flash ${STLINK_LIB_STATIC} ${SSP_LIB})
    target_link_libraries(st-info ${STLINK_LIB_STATIC} ${SSP_LIB})
    target_link_libraries(st-util ${STLINK_LIB_STATIC} ${SSP_LIB})
else ()
    target_link_libraries(st-flash ${STLINK_LIB_SHARED} ${SSP_LIB})
    target_link_libraries(st-info ${STLINK_LIB_SHARED} ${SSP_LIB})
    target_link_libraries(st-util ${STLINK_LIB_SHARED} ${SSP_LIB})
endif ()

install(TARGETS st-flash DESTINATION ${CMAKE_INSTALL_BINDIR})
install(TARGETS st-info DESTINATION ${CMAKE_INSTALL_BINDIR})
install(TARGETS st-util DESTINATION ${CMAKE_INSTALL_BINDIR})


###
# Device configuration (Linux only)
###

if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
    ## Install modprobe.d conf files to /etc/modprobe.d/ (explicitly hardcoded)
    set(STLINK_MODPROBED_DIR "/etc/modprobe.d" CACHE PATH "modprobe.d directory")
    install(FILES ${CMAKE_SOURCE_DIR}/config/modprobe.d/stlink_v1.conf DESTINATION ${STLINK_MODPROBED_DIR})

    ## Install udev rules files to /etc/udev/rules.d/ (explicitly hardcoded)
    set(STLINK_UDEV_RULES_DIR "/etc/udev/rules.d" CACHE PATH "udev rules directory")
    file(GLOB RULES_FILES ${CMAKE_SOURCE_DIR}/config/udev/rules.d/*.rules)
    install(FILES ${RULES_FILES} DESTINATION ${STLINK_UDEV_RULES_DIR})
endif ()


###
# Additional build tasks
###

# ====
add_subdirectory(include) # contains subordinate CMakeLists for version config and old header includes
                                                                                ### TODO: Clean this up ...
# ====

add_subdirectory(src/stlink-gui)  # contains subordinate CMakeLists to build GUI
add_subdirectory(tests)           # contains subordinate CMakeLists to build test executables
add_subdirectory(cmake/packaging) # contains subordinate CMakeLists to build packages

option(STLINK_GENERATE_MANPAGES "Generate manpages with pandoc" OFF)
add_subdirectory(doc/man)         # contains subordinate CMakeLists to generate manpages


###
# Uninstall target
###

if (NOT TARGET uninstall)
    configure_file(
        "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
        "${CMAKE_CURRENT_BINARY_DIR}/cmake/cmake_uninstall.cmake"
        IMMEDIATE @ONLY
        )
    add_custom_target(
        uninstall COMMAND ${CMAKE_COMMAND}
        -P ${CMAKE_CURRENT_BINARY_DIR}/cmake/cmake_uninstall.cmake
        )
endif ()

=== flashloaders/Makefile ===
# Note that according to the original GPLed code, compiling is noted to be
# as simple as gcc -c, this fails with my tests where this will lead to a wrong 
# address read by the program.
# This makefile will save your time from dealing with compile errors
# Adjust CC if needed

CC = /opt/local/gcc-arm-none-eabi-8-2018-q4-major/bin/arm-none-eabi-gcc

CFLAGS_thumb1 = -mcpu=Cortex-M0  -Tlinker.ld -ffreestanding -nostdlib
CFLAGS_thumb2 = -mcpu=Cortex-M3  -Tlinker.ld -ffreestanding -nostdlib

all: stm32vl.o stm32f0.o stm32l.o stm32f4.o stm32f4_lv.o stm32l4.o stm32f7.o stm32f7_lv.o

stm32vl.o: stm32f0.s
	$(CC) stm32f0.s $(CFLAGS_thumb2)  -o stm32vl.o
stm32f0.o: stm32f0.s
	$(CC) stm32f0.s $(CFLAGS_thumb1)  -o stm32f0.o
stm32l.o: stm32lx.s
	$(CC) stm32lx.s $(CFLAGS_thumb2)  -o stm32l.o
stm32f4.o: stm32f4.s
	$(CC) stm32f4.s $(CFLAGS_thumb2)  -o stm32f4.o
stm32f4_lv.o: stm32f4lv.s
	$(CC) stm32f4lv.s $(CFLAGS_thumb2)  -o stm32f4_lv.o
stm32l4.o: stm32l4.s
	$(CC) stm32l4.s $(CFLAGS_thumb2)  -o stm32l4.o
stm32f7.o: stm32f7.s
	$(CC) stm32f7.s $(CFLAGS_thumb2)  -o stm32f7.o
stm32f7_lv.o: stm32f7lv.s
	$(CC) stm32f7lv.s $(CFLAGS_thumb2)  -o stm32f7_lv.o

clean:
	rm *.o

=== include/CMakeLists.txt ===
configure_file(
    "${PROJECT_SOURCE_DIR}/include/stlink/version.h.in"
    "${CMAKE_BINARY_DIR}/include/stlink/version.h"
    )

file(GLOB STLINK_HEADERS "stlink/*.h" "${CMAKE_BINARY_DIR}/include/stlink/*.h")
install(FILES ${CMAKE_SOURCE_DIR}/include/stlink.h DESTINATION ${STLINK_INCLUDE_PATH})
install(FILES ${CMAKE_SOURCE_DIR}/include/stm32.h DESTINATION ${STLINK_INCLUDE_PATH})
install(FILES ${STLINK_HEADERS} DESTINATION ${STLINK_INCLUDE_PATH}/stlink)

=== tests/CMakeLists.txt ===
###
# Build test executables
###

set(TESTEXEC usb sg)

foreach (test ${TESTEXEC})
    add_executable(test-${test} ${test}.c)
    add_dependencies(test-${test} ${STLINK_LIB_SHARED})
    target_link_libraries(test-${test} ${STLINK_LIB_SHARED} ${SSP_LIB})
    add_test(test-${test} ${CMAKE_BINARY_DIR}/bin/test-${test})
endforeach ()

add_executable(test-flash flash.c "${CMAKE_SOURCE_DIR}/src/tools/flash_opts.c")
target_link_libraries(test-flash ${STLINK_LIB_SHARED} ${SSP_LIB})
add_test(test-flash ${CMAKE_BINARY_DIR}/bin/test-flash)

=== doc/man/CMakeLists.txt ===
###
# Generate manpages
###

set(MANPAGES st-util st-flash st-info)

# Only generate manpages with pandoc in Debug builds
if (${STLINK_GENERATE_MANPAGES})
    include(pandocology)
    foreach (manpage ${MANPAGES})
        add_document(
            ${manpage}.1
            SOURCES ${manpage}.md
            PANDOC_DIRECTIVES -s -t man
            PRODUCT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
            )
    endforeach ()
else ()
    message(STATUS "Manpage generation disabled")
endif ()

# Install from output folder or this folder
foreach (manpage ${MANPAGES})
    if (EXISTS ${CMAKE_CURRENT_BINARY_DIR}/${manpage}.1)
        set(f "${CMAKE_CURRENT_BINARY_DIR}/${manpage}.1")
    elseif (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${manpage}.1")
        set(f "${CMAKE_CURRENT_SOURCE_DIR}/${manpage}.1")
    else()
        message(AUTHOR_WARNING "Manpage ${manpage} not generated")
    endif ()

    if (f AND NOT WIN32)
        install(FILES ${f} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/man/man1)
        unset(f)
    endif ()
endforeach ()

=== src/stlink-gui/CMakeLists.txt ===
###
# Build GUI
###

if (NOT WIN32)
    ## GUI-Building requires the presence of a GTK3 toolset
    if (NOT GTK3_FOUND)
        message(STATUS "GTK3 not found!")
        return() # no GTK3 present => no GUI build
    else (GTK3_FOUND)
        message(STATUS "Found GTK3: -I${GTK3_INCLUDE_DIRS}, ${GTK3_LIBRARIES}")
        include_directories(SYSTEM ${GTK3_INCLUDE_DIRS})

        # Install desktop application entry
        install(FILES stlink-gui.desktop
                DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/applications)

        # Install icons
        install(FILES icons/stlink-gui.svg
                DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/icons/hicolor/scalable/apps)

        set(GUI_SOURCES gui.c gui.h)

        ## stlink-gui-local
        add_executable(stlink-gui-local ${GUI_SOURCES})
        file(COPY stlink-gui.ui DESTINATION ${CMAKE_BINARY_DIR}/bin)
        set_target_properties(stlink-gui-local PROPERTIES
                COMPILE_DEFINITIONS STLINK_UI_DIR="${CMAKE_BINARY_DIR}/bin")
        target_link_libraries(stlink-gui-local ${STLINK_LIB_SHARED} ${SSP_LIB} ${GTK3_LDFLAGS})

        ## stlink-gui
        add_executable(stlink-gui ${GUI_SOURCES})
        install(FILES stlink-gui.ui DESTINATION ${CMAKE_INSTALL_BINDIR})
        set_target_properties(stlink-gui PROPERTIES
                COMPILE_DEFINITIONS STLINK_UI_DIR="${CMAKE_INSTALL_PREFIX}/bin")
        target_link_libraries(stlink-gui ${STLINK_LIB_SHARED} ${SSP_LIB} ${GTK3_LDFLAGS})
        install(TARGETS stlink-gui DESTINATION ${CMAKE_INSTALL_BINDIR})


    endif ()
endif ()

=== debian/changelog ===
stlink (1.6.1+ds-1) unstable; urgency=medium

  * Merge tag 'v1.6.1' into debian
  * Update Files-Excluded in d/copyright for new layout
  * Fix d/watch intermediary file name
  * Drop cross.patch, merged upstream in v1.6.1
  * Bump Build-Depends to cmake >= 3.4.2
  * Add new symbols from upstream version 1.6.1
  * Adjust install files, some files moved
  * Remove unused variable from d/rules
  * Generate pkgconfig file from d/rules, upstream doesn't do it
  * Switch to debhelper-compat 12

 -- Luca Boccassi <bluca@debian.org>  Sat, 06 Jun 2020 14:44:54 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: stlink
 Priority: optional
 Maintainer: Luca Boccassi <bluca@debian.org>
-Build-Depends: debhelper (>= 9), cmake, libusb-1.0-0-dev, libgtk-3-dev
+Build-Depends: debhelper-compat (= 12), cmake (>= 3.4.2), libusb-1.0-0-dev, libgtk-3-dev
 Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Section: electronics

=== debian/watch ===
version=3
opts=dversionmangle=s/\+ds$//,repacksuffix=+ds,filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/stlink-$1\.tar\.gz/ \
  https://github.com/texane/stlink/tags .*/v?(\d\S+)\.tar\.gz

## stlink 1.7.0%2Bds

=== debian/changelog ===
stlink (1.7.0+ds-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Luca Boccassi <bluca@debian.org>  Fri, 23 Sep 2022 11:15:33 +0100

stlink (1.7.0+ds-1) unstable; urgency=medium

  * Merge tag 'v1.7.0' into debian. (Closes: #984356)
  * Bump Standards-Version to 4.5.1, no changes.
  * Bump debhelper-compat to 13, no changes.
  * Update install files, paths have been fixed upstream.
  * Update symbols file for 1.7.0.

 -- Luca Boccassi <bluca@debian.org>  Sun, 15 Aug 2021 14:23:25 +0100

stlink (1.6.1+ds-3) unstable; urgency=medium

  * Add cross.patch to fix cross-compilation. Thanks Helmut! (Closes:
    #973339)

 -- Luca Boccassi <bluca@debian.org>  Thu, 29 Oct 2020 18:06:39 +0000

stlink (1.6.1+ds-2) unstable; urgency=medium

  * Update d/copyright to remove GPL-2+ stanza about flashloaders
  * Update upstream URLs for new Github org
  * Patch CMake's hard-coded define of XML gui file location (Closes:
    #963219)

 -- Luca Boccassi <bluca@debian.org>  Sun, 21 Jun 2020 13:41:37 +0100
